/**
 * 
 */
package com.pcag.java.oea.plugins.demoexchange2008.model;

import com.pcag.java.oea.plugins.demoexchange2008.model.api.IDBType;

/**
 * @author Johannes Imhof
 * 
 */
public class DBType implements IDBType {

	private int portOffset;
	private String physicalName;
	private String logicalName;
	private static int internalPortOffset = 5;

	public DBType() {
		super();
	}

	public DBType(String physicalName, String logicalName) {
		super();

		this.physicalName = physicalName;
		this.logicalName = logicalName;
		this.portOffset = this.getInternalPortOffset(physicalName);
	}

	public DBType(DefaultDBTypes defaults) {

		this.physicalName = defaults.getPhysicalName();
		this.logicalName = defaults.getLogicalName();
		this.portOffset = defaults.getPortOffset();

	}

	private int getInternalPortOffset(String dbtype) {
		int result;

		if (physicalName.equals(DefaultDBTypes.FIX.getPhysicalName()))
			result = DefaultDBTypes.FIX.getPortOffset();
		else if (physicalName.equals(DefaultDBTypes.VAR.getPhysicalName()))
			result = DefaultDBTypes.VAR.getPortOffset();
		else if (physicalName.equals(DefaultDBTypes.TMP.getPhysicalName()))
			result = DefaultDBTypes.TMP.getPortOffset();
		else if (physicalName.equals(DefaultDBTypes.HR.getPhysicalName()))
			result = DefaultDBTypes.HR.getPortOffset();
		else {
			DBType.internalPortOffset++;
			result = DBType.internalPortOffset;
		}
		return result;
	}

	/**
	 * @return the logicalName
	 */
	public String getLogicalName() {
		return logicalName;
	}

	/**
	 * @param logicalName
	 *          the logicalName to set
	 */
	public void setLogicalName(String logicalName) {
		this.logicalName = logicalName;
	}

	/**
	 * @return the physicalName
	 */
	public String getPhysicalName() {
		return physicalName;
	}

	/**
	 * @param physicalName
	 *          the physicalName to set
	 */
	public void setPhysicalName(String physicalName) {
		this.physicalName = physicalName;
	}

	/**
	 * @return the portOffset
	 */
	public int getPortOffset() {
		return portOffset;
	}

	/**
	 * @param portOffset
	 *          the portOffset to set
	 */
	public void setPortOffset(int portOffset) {
		this.portOffset = portOffset;
	}
}
