package com.pcag.java.oea.plugins.demoexchange2008.wizard;

import org.eclipse.core.runtime.Preferences;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.pcag.java.oea.plugins.demoexchange2008.Activator;
import com.pcag.java.oea.plugins.demoexchange2008.preferences.PreferenceConstants;

public class NewDatabaseconnectionWizardPage extends WizardPage {

	private Label labelUsername;
	private Label labelPassword;
	private Label labelNamePrefix;
	private Text username;
	private Text password;
	private Text namePrefix;

	private static final int SIZING_TEXT_FIELD_WIDTH = 250;

	protected NewDatabaseconnectionWizardPage(String pageName) {
		super(pageName);
		setTitle("Initialize database connection");
		setDescription("This wizard initializes our standard database connections for the current project");		
	}

	public void createControl(Composite parent) {
    initializeDialogUnits(parent);

		
		Composite container = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		container.setLayout(layout);
		layout.numColumns = 2;
		layout.verticalSpacing = 9;

		{
			labelUsername = new Label(container, SWT.NONE);
			GridData labelProjectLData = new GridData();
			labelProjectLData.horizontalIndent = 1;
			labelUsername.setText("&Username:");
		}
		{
			username = new Text(container, SWT.BORDER);
			GridData projectNameLData1 = new GridData();
			projectNameLData1.horizontalAlignment = GridData.FILL;
			projectNameLData1.grabExcessHorizontalSpace = true;
			projectNameLData1.widthHint = SIZING_TEXT_FIELD_WIDTH;
			username.setLayoutData(projectNameLData1);
			username.addModifyListener(new ModifyListener() {
				public void modifyText(ModifyEvent e) {
					//beep();
				}
			});
		}

		{
			labelPassword = new Label(container, SWT.NONE);
			GridData labelProjectLData = new GridData();
			labelProjectLData.horizontalIndent = 1;
			labelPassword.setText("&Password:");
		}
		{
			password = new Text(container, SWT.BORDER);
			GridData projectNameLData1 = new GridData();
			projectNameLData1.horizontalAlignment = GridData.FILL;
			projectNameLData1.grabExcessHorizontalSpace = true;
			projectNameLData1.widthHint = SIZING_TEXT_FIELD_WIDTH;
			password.setLayoutData(projectNameLData1);
			password.addModifyListener(new ModifyListener() {
				public void modifyText(ModifyEvent e) {
					//beep();
				}
			});
		}

		{
			labelNamePrefix = new Label(container, SWT.NONE);
			GridData labelProjectLData = new GridData();
			labelProjectLData.horizontalIndent = 1;
			labelNamePrefix.setText("&Name prefix:");
		}
		{
			namePrefix = new Text(container, SWT.BORDER);
			GridData projectNameLData1 = new GridData();
			projectNameLData1.horizontalAlignment = GridData.FILL;
			projectNameLData1.grabExcessHorizontalSpace = true;
			projectNameLData1.widthHint = SIZING_TEXT_FIELD_WIDTH;
			namePrefix.setLayoutData(projectNameLData1);
			namePrefix.addModifyListener(new ModifyListener() {
				public void modifyText(ModifyEvent e) {
					//beep();
				}
			});
		}

		
		initialize();
		
    validatePage();
    
    // Show description on opening
    setErrorMessage(null);
    setMessage(null);
    setControl(container);
	}

  private void initialize() {

		Preferences prefs = Activator.getDefault().getPluginPreferences();

  	username.setText(prefs.getString(PreferenceConstants.P_DBUSERNAME));
  	password.setText(prefs.getString(PreferenceConstants.P_DBPASSWORD));  	
	}

	/**
   * Returns whether this page's controls currently all contain valid 
   * values.
   *
   * @return <code>true</code> if all controls are valid, and
   *   <code>false</code> if at least one is invalid
   */
  protected boolean validatePage() {
      boolean valid = true;

      return valid;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.WizardPage#isPageComplete()
	 */
	@Override
	public boolean isPageComplete() {
		return true;
	}

	public String getUsername() {
		return username.getText();
	}
	
	public String getPassword() {
		return password.getText();
	}
	
	public String getNamePrefix() {
		return namePrefix.getText();
	}
	

}
